INCLUDE KEYDEFS.H
ASSEMBLE
NBROMID EQU #407
RPL

xROMID 407

ASSEMBLE
* ROM-Symbols I need, but HP didn't provide...
RCLUSERF        EQU #1c64e
STOUSERF        EQU #1c6f7
#LibLen         EQU #0809e
#LibNam         EQU #081b9
#TagRcl         EQU #21761
#TagPurge       EQU #217f1
#TagSto         EQU #214f4
#Err204         EQU #18c92
#NoClock        EQU #53aba
RPL

EXTERNAL NBaboutme
EXTERNAL NBconfirm
EXTERNAL NBgetKey
EXTERNAL NBcls
EXTERNAL NBfindRec
EXTERNAL NBrclPar
EXTERNAL NBrclVar
EXTERNAL NBstoVar
EXTERNAL NBparchk
EXTERNAL NBparInvalid
EXTERNAL NBEditStr
EXTERNAL NBinsRec
EXTERNAL NBdelRec
EXTERNAL NBeditRec
EXTERNAL NBkOn
EXTERNAL NBmain
EXTERNAL NBgo
EXTERNAL NBplainKey
EXTERNAL NBrightKey
EXTERNAL NBleftKey
EXTERNAL NBpol
EXTERNAL NBstdkey
EXTERNAL NBshowProc

DEFINE rl_name          18GETLAM
DEFINE sl_name          18PUTLAM
DEFINE rl_var           17GETLAM
DEFINE sl_var           17PUTLAM
DEFINE rl_flds          16GETLAM
DEFINE sl_flds          16PUTLAM
DEFINE rl_srch          15GETLAM
DEFINE sl_srch          15PUTLAM
DEFINE rl_flags         14GETLAM
DEFINE sl_flags         14PUTLAM
DEFINE rl_show		13GETLAM
DEFINE sl_show          13PUTLAM
DEFINE rl_opts          12GETLAM
DEFINE sl_opts          12PUTLAM
DEFINE rl_t1            11GETLAM
DEFINE sl_t1            11PUTLAM
DEFINE rl_t2            10GETLAM
DEFINE sl_t2            10PUTLAM
DEFINE rl_t3            9GETLAM
DEFINE sl_t3            9PUTLAM
DEFINE rl_t4            8GETLAM
DEFINE sl_t4            8PUTLAM
DEFINE rl_t5            7GETLAM
DEFINE sl_t5            7PUTLAM
DEFINE rl_cur           6GETLAM
DEFINE sl_cur           6PUTLAM
DEFINE rl_off           5GETLAM
DEFINE sl_off           5PUTLAM
DEFINE rl_nf            4GETLAM
DEFINE sl_nf            4PUTLAM
DEFINE rl_nr            3GETLAM
DEFINE sl_nr            3PUTLAM
DEFINE rl_data          2GETLAM
DEFINE sl_data          2PUTLAM
DEFINE rl_stopnow       1GETLAM
DEFINE sl_stopnow       1PUTLAM

* -----------------------------------------------------------------------------
ASSEMBLE
        CON(1) 8
RPL
xNAME NB
        :: 
	    ' :: 
	        NBrclPar 
		' NBpol 
		MenuKeyNS! 
		' ::
		    RECLAIMDISP SetDA12Temp
		    SIX #1+_ONE_DO (DO)
			INDEX@ GETPROC
			DUPTYPELIST? ITE
			    :: ONE NTHELCOMP NOT_IT NBparInvalid COERCE$22 ;
			    DROPNULL$
			INDEX@ DISPN
		    LOOP
		    ; 
		ReviewKey! 
		;
	    InitMenu 
	;
* -----------------------------------------------------------------------------
ASSEMBLE
        CON(1) 8
RPL
xNAME NBmmdd
        ::
        "0000"
        TOTEMPOB
        DATE
CODE
        GOSBVL      =POPDATE%
        SETHEX
        R0=C
        GOSBVL      =GETPTR
        A=DAT1      A
        AD1EX
        D1=D1+      10
        D1=D1+      6
        C=R0
        GONC        lastfour
ENDCODE
        ;
* -----------------------------------------------------------------------------
ASSEMBLE
        CON(1) 8
RPL
xNAME NByymmdd
        ::
        "000000"
        TOTEMPOB
        DATE
CODE
        GOSBVL      =POPDATE%
        SETHEX
        R0=C
        GOSBVL      =GETPTR
        A=DAT1      A
        AD1EX
        D1=D1+      10
        D1=D1+      10
        C=R0
        DAT1=C      1
        D1=D1-      2
        CSR         W
        DAT1=C      1
        D1=D1-      2
        CSR         W
lastfour
        DAT1=C      1
        D1=D1-      2
        CSR         W
        DAT1=C      1
        D1=D1-      2
        CSR         W
        DAT1=C      1
        D1=D1-      2
        CSR         W
        DAT1=C      1
        D1=A
        GOVLNG      =GETPTRLOOP
ENDCODE
        ;

* -----------------------------------------------------------------------------
ASSEMBLE
        CON(1) 8
RPL
xNAME NBstart
        ::
        CK1&Dispatch
        list
            NBpol
	real		( index into NBPAR )
	    :: COERCE NBrclPar SWAP NTHCOMPDROP TWO NTHCOMPDROP xNBstart ;
        ;
* -----------------------------------------------------------------------------
ASSEMBLE
        CON(1) 8
RPL
xNAME aboutNB
        :: CK0 RECLAIMDISP NBaboutme ;
* -----------------------------------------------------------------------------
NULLNAME NBcls
CODE
	GOSBVL      =SAVPTR
	P=          0
	SETHEX
	GOSBVL      =D0->Row1
	LC(5)       #76
	A=0         W
	GOSBVL      #01c23
	GOVLNG      =GETPTRLOOP
ENDCODE
* -----------------------------------------------------------------------------
NULLNAME NBaboutme
        ::
	TakeOver
        NBcls 
	DOBINT NBROMID #LibNam DROP ID>$ DISPROW1
        "  Poul-Henning Kamp"            DISPROW3
        "   phk@data.fls.dk"             DISPROW5
        "[GNU CopyLeft applies]"         DISPROW7
        SetDA12Temp
        ;

* -----------------------------------------------------------------------------
NULLNAME NBconfirm
        ::
	DISPROW6
        "press ENTER/ON (y/n)" DISPROW7
        WaitForKey DROP TWENTYFIVE #=
        ;

* -----------------------------------------------------------------------------
NULLNAME NBshowProc
	::
	#6* sl_t2
	ZERO sl_t1
	INNERCOMP
	DUP#1= ITE
	    DROP
	    ::
	    ONE_DO (DO)
		SWAP DUPNULL$? ITE
		    DROP
		    :: "\n" &$ SWAP&$ ;
	    LOOP
	    ;
	BEGIN
	    DUPNULL$? NOT
	WHILE 
	    SEP$NL rl_t2 #0=ITE
		:: rl_t1 #1+DUP sl_t1 DISPN rl_t1 SEVEN #< ?SEMI DROPNULL$ ;
		:: DROP rl_t2 #1- sl_t2 ;
	REPEAT
	DROP
	;
* -----------------------------------------------------------------------------
NULLNAME NBfindRec
        ::
	rl_data SWAP
        '
CODE
        GOSBVL      =SAVPTR
        C=DAT1      A
        D0=C
        D0=D0+      5
        D1=D1+      5
        C=DAT1      A
        D1=C
        D1=D1+      10
        LC(5)       #5
        A=DAT0      A
        D0=D0+      5
        A=A-C       A
        A=0         M
        ASRB
        B=C         A
        BAEX        A
        C=DAT1      A
        D1=D1+      5
        C=C-A       A
        C=0         M
        CSRB
        D=C         A
        D=D-1       A
        GOC         loc00487
        B=B-1       A
        GOC         loc00467
loc00447
        A=DAT0      B
        C=DAT1      B
        D0=D0+      2
        D1=D1+      2
        ?C>A        B
        GOYES       loc00467
        ?C<A        B
        GOYES       loc00487
        D=D-1       A
        GOC         loc00482
        B=B-1       A
        GONC        loc00447
loc00467
        LC(5)       =TRUE
loc0046e
        A=C         A
        GOSBVL      =GETPTR
        D1=D1+      10
        D=D+1       A
        D=D+1       A
        PC=(A)
loc00482
        B=B-1       A
        GOC         loc00467
loc00487
        LC(5)       =FALSE
        GOTO        loc0046e
ENDCODE
        POSCOMP
        ;
* -----------------------------------------------------------------------------
NULLNAME NBrclVar
        ::
	rl_var
	    ::
	    CK&DISPATCH1
		list
		    ::
		    ERRSET
			:: LISTRCL ;
		    ERRTRAP
			:: ERROR@ # 00204 #<>case ERRJMP ERRORCLR NULL{} ;
		    ;
		idnt
		    :: RclHiddenVar NOT_IT NULL{} ;
		THIRTEEN
		    :: ERRSET #TagRcl ERRTRAP :: ERRORCLR NULL{} ; ;
	    ;
        DUP sl_data LENCOMP sl_nr
	SIXTYFOUR ClrUserFlag
	;
* -----------------------------------------------------------------------------
NULLNAME NBstoVar
        ::
	rl_data rl_var CK&DISPATCH1
	THIRTEEN
            :: DUP ERRSET #TagPurge ERRTRAP ERRORCLR #TagSto ;
        list
            ::
            CONTEXT@
            sl_t1
            ERRSET
                :: INNERCOMP SWAP sl_t2 #1- {}N LISTRCL DUPTYPERRP?
                NOT_IT #Err204 CONTEXT!  rl_t2 XEQSTOID ;
            ERRTRAP
                :: rl_t1 CONTEXT! ERRJMP ;
            rl_t1 CONTEXT!
            ;
        idnt
            StoHiddenVar
        ;
* -----------------------------------------------------------------------------
NULLNAME NBparchk
        ::
        INNERCOMP DUPDUP
        #<3 SWAP SEVEN #> ANDcase
            :: NDROP NBparInvalid ;
        #1+
        EIGHTEEN 
        { NOP NOP NOP NULL$ HXS 1 0 %1 NULL{} FALSE FALSE FALSE FALSE FALSE 
        ONE ZERO ZERO ZERO NULL{} FALSE }
	XYZ>ZXY SUBCOMP INCOMPDROP 
        { LAM name LAM var LAM flds LAM srch LAM flags LAM show LAM opts
	LAM t1 LAM t2 LAM t3 LAM t4 LAM t5 LAM cur LAM off LAM nf
        LAM nr LAM data LAM NBcontext }
	BIND
        NBrclVar
        rl_flds LENCOMP sl_nf

	rl_show TYPEREAL? IT
	    :: ' NBshowProc sl_show ;

        rl_nr #0=?SEMI

        rl_srch EVAL NBfindRec ONE #MAX sl_cur
        HXS 5 FFFFF rl_flags bitAND STOUSERF
        ;
* -----------------------------------------------------------------------------
NULLNAME NBparInvalid
        :: "NBPAR invalid" DO$EXIT ;
* -----------------------------------------------------------------------------
NULLNAME NBEditStr
        :: #ZERO#ONE ONEONE EditMenu ONE TRUE ZERO InputLine ;
* -----------------------------------------------------------------------------
NULLNAME NBinsRec
        ::
	INNERCOMP sl_t1
	BEGIN
	    DUPNULL$? rl_t1 ONE#> AND
	WHILE
	    DROP rl_t1 #1- sl_t1
	REPEAT
	rl_t1
	#1+_ONE_DO (DO)
	    DUPNULL$? IT DROPNULL$
	    rl_t1 ROLL
	LOOP
	rl_t1 {}N DUPONE NTHCOMPDROP
        NBfindRec DUP#0=IT :: DROP rl_nr #1+ ;
        sl_cur 
	rl_data SWAP sl_data
	INNERCOMP rl_cur #- #2+
        rl_data SWAP UNROLL rl_nr #1+DUP 
	sl_nr {}N sl_data SIXTYFOUR SetUserFlag
	ClrDA1OK
        ;
* -----------------------------------------------------------------------------
NULLNAME NBdelRec
        ::
        rl_data INNERCOMP rl_cur #- #1+ ROLLDROP
        rl_nr #1- DUPDUP rl_cur #MIN sl_cur
	sl_nr {}N sl_data SIXTYFOUR SetUserFlag
        ;
* -----------------------------------------------------------------------------
NULLNAME NBeditRec
        ::
	DUP LENCOMP DUP sl_t1 rl_nf #MAX
        #1+_ONE_DO (DO)
	    rl_flds INDEX@ NTHELCOMP ?SKIP NULL$
	    OVER INDEX@ NTHELCOMP ?SKIP NULL$ 
	    NBEditStr
	    ITE
		::
		INDEX@ rl_t1 #>ITE
		    >TCOMP
		    :: INDEX@ ROT PUTLIST ;
		;
		ExitAtLOOP
        LOOP
        DispMenu.1
	NBinsRec
        ;
* -----------------------------------------------------------------------------
NULLNAME NBrclPar
        ::
        ' ID NBPAR Sys@ ?SEMI
	"NBPAR undefined"
	DO$EXIT
        ;

* -----------------------------------------------------------------------------
NULLNAME NBstdkey
        ::
	DUP#<7              casedrpfls
	kcRightShift        #=casedrpfls
	kcLeftShift         #=casedrpfls
	DROP 'DoBadKeyT
	;
* -----------------------------------------------------------------------------
NULLNAME NBpol
        ::
        RECLAIMDISP             ( : get TEXT-display )
        ClrDA1IsStat            ( : Disable Clock)
        FALSE
	RCLSYSF RCLUSERF TWO{}N
        { LAM Exit NULLLAM }
        BIND
        ' ( AppDisplay)
	    ::
	    KEYINBUFFER? ?SEMI DA1OK? ?SEMI NBcls SetDA1Valid
	    rl_nr #0= case :: "     [No Records]" DISPROW4 ;
	    rl_data rl_cur NTHCOMPDROP rl_off rl_show EVAL
	    ;
        ' ( AppKeys )
	    ::
	    kpNoShift #=casedrop
		::
		kcLeftArrow     ?CaseKeyDef :: TakeOver 
		    rl_cur #1- ONE #MAX sl_cur ZERO sl_off ClrDA1OK ;
		kcRightArrow    ?CaseKeyDef :: TakeOver 
		    rl_cur #1+ rl_nr #MIN sl_cur ZERO sl_off ClrDA1OK ;
		kcUpArrow       ?CaseKeyDef :: TakeOver
		    rl_off ONE #MAX #1- sl_off ClrDA1OK ;
		kcDownArrow     ?CaseKeyDef :: TakeOver
		    rl_off #1+ sl_off ClrDA1OK ;
		kcOn            ?CaseKeyDef :: TakeOver TRUE ' LAM Exit STO ;
		kcSto		?CaseKeyDef :: TakeOver 
		    ONE TestUserFlag ?SEMI NBstoVar NBrclVar ClrDA1OK ;
		NBstdkey
		;
	    kpRightShift #=casedrop
		::
		kcLeftArrow     ?CaseKeyDef :: TakeOver 
		    ONE sl_cur ZERO sl_off ClrDA1OK ;
		kcRightArrow    ?CaseKeyDef :: TakeOver
		    rl_nr sl_cur ZERO sl_off ClrDA1OK ;
		kcUpArrow       ?CaseKeyDef :: TakeOver
		    rl_nr #0=?SEMI
		    rl_data rl_cur NTHCOMPDROP TOTEMPOB ;
		kcDownArrow     ?CaseKeyDef :: TakeOver 
		    ONE TestUserFlag ?SEMI
		    DEPTH #0= ?SEMI
		    DUPTYPELIST? ITE
			::
			INNERDUP 1LAMBIND
			#1+_ONE_DO (DO)
			    DUPTYPECSTR? ?SKIP DECOMP$ 1GETLAM ROLL
			LOOP
			1GETABND {}N
			;
			:: DUPTYPECSTR? ?SKIP DECOMP$ ONE{}N ;
		    NBinsRec
		    ;
		kcOn            ?CaseKeyDef :: TakeOver
		    TRUE ' LAM Exit STO NBcls TurnOff ;
		kcSto		?CaseKeyDef :: TakeOver
		    SIXTYFOUR TestUserFlag NOT?SEMI
		    "Forget all changes ?" NBconfirm NOT?SEMI
		    NBrclVar ClrDA1OK ;
		NBstdkey
		;
	    kpLeftShift #=casedrop
		::
		kcDownArrow     ?CaseKeyDef :: TakeOver 
		    NBcls
		    rl_name DISPROW1
		    rl_var DO>STR DISPROW2
		    "Rec " rl_cur #>$ &$ " of " &$ rl_nr #>$ &$ DISPROW3
		    "Size " rl_data OCRC DROP #2/ #>$ &$ " bytes" &$ DISPROW4
		    ONE TestUserFlag IT :: "Read-Only" DISPROW6 ;
		    SIXTYFOUR TestUserFlag IT :: "Changed" DISPROW6 ;
		    "Free " GARBAGE MEM #2/ #>$ &$ " bytes" &$ DISPROW5
		    SetDA1Temp
		    ;
		kcOn            ?CaseKeyDef NBaboutme
		NBstdkey
		;
	    2DROP 'DoBadKeyT
	    ;
        TrueTrue                ( NonAppKeyOK? ) ( DoStdKeys? )
        ( AppMenu )
	    {
		{ "Find"    ::  TakeOver rl_nr #0=?SEMI
				"Find What ?" rl_srch EVAL NBEditStr
				DispMenu.1 NOT?SEMI
				NBfindRec ONE #MAX sl_cur ; }
		{ "Edit"    ::  TakeOver rl_nr #0=?SEMI ONE TestUserFlag ?SEMI
				rl_data rl_cur NTHCOMPDROP NBdelRec 
				NBeditRec ; }
		{ "Add"     ::  TakeOver ONE TestUserFlag ?SEMI
				rl_nf #1+_ONE_DO NULL$ [LOOP] 
				rl_nf {}N NBeditRec ; }
		{ "Del"     ::  TakeOver rl_nr #0=?SEMI ONE TestUserFlag ?SEMI
				"Delete this record ?" NBconfirm IT NBdelRec ; }
		{ "Copy"    ::  TakeOver rl_nr #0=?SEMI ONE TestUserFlag ?SEMI
				rl_data rl_cur NTHCOMPDROP NBeditRec ; }
		NullMenuKey 
	    }
        ONEFALSE                ( #AppMenuRow ) ( SuspendOK? )
        ' LAM Exit              ( ExitCond )
        ' ERRJMP                ( AppError )
        POLSaveUI
        ERRSET
            :: POLSetUI NBparchk DispMenu.1 #NoClock POLKeyUI
            SIXTYFOUR TestUserFlag IT NBstoVar
            ;
        ERRTRAP
            POLResUI&Err
        POLRestoreUI
        ClrDAsOK 1GETABND xSTOF
        ;
